var teletypeGadget = new TeletypeGadget();
var rss = null;


function PrepareControlCore(path, rootCls, rootPid, rootTypeLib, clsid, prgid, dllname, name, typelib)
{
    var wshShell = new ActiveXObject("WScript.Shell"); 
    
    wshShell.RegWrite (rootPid, name);
    wshShell.RegWrite (rootPid+"CLSID\\", "{"+clsid+"}");
    wshShell.RegWrite (rootCls, prgid);
    wshShell.RegWrite (rootCls+"InprocServer32\\", path);
    wshShell.RegWrite (rootCls+"InprocServer32\\ThreadingModel", "Apartment");
    wshShell.RegWrite (rootCls+"Implemented Categories\\{7DD95801-9882-11CF-9FA9-00AA006C42C4}\\", "");
    wshShell.RegWrite (rootCls+"Implemented Categories\\{7DD95802-9882-11CF-9FA9-00AA006C42C4}\\", "");   
    
    wshShell.RegWrite (rootCls+"MiscStatus\\1\\", "131473");     
    wshShell.RegWrite (rootCls+"Control\\", "");
    wshShell.RegWrite (rootCls+"Insertable\\", "");
    wshShell.RegWrite (rootCls+"Programmable\\", "");  
    wshShell.RegWrite (rootCls+"VersionIndependentProgID\\", "prgid");  
    wshShell.RegWrite (rootCls+"TypeLib\\", "{"+typelib+"}");  
    
    wshShell.RegWrite (rootTypeLib, name+" 1.0 Type Library");
    wshShell.RegWrite (rootTypeLib+"0\\win32\\", path);  
    wshShell.RegWrite (rootTypeLib+"FLAGS\\", "0");  
    wshShell.RegWrite (rootTypeLib+"HELPDIR\\", path);  
}

function PrepareControl(path, clsid, prgid, dllname, name, typelib)
{
    var rootCls = "HKCU\\Software\\Classes\\CLSID\\{" + clsid + "}\\";
    var rootPid = "HKCU\\SOFTWARE\\Classes\\" + prgid + "\\";
    var rootTypeLib =  "HKCU\\SOFTWARE\\Classes\\TypeLib\\{" + typelib + "}\\1.0\\";
    try{
    PrepareControlCore(path, rootCls, rootPid, rootTypeLib, clsid, prgid, dllname, name, typelib);
    }catch(e){}
   
    rootCls = "HKLM\\Software\\Classes\\CLSID\\{" + clsid + "}\\";
    rootPid = "HKLM\\SOFTWARE\\Classes\\" + prgid + "\\";
    rootTypeLib =  "HKLM\\SOFTWARE\\Classes\\TypeLib\\{" + typelib + "}\\1.0\\";
    try{
    PrepareControlCore(path, rootCls, rootPid, rootTypeLib, clsid, prgid, dllname, name, typelib);
    }catch(e){} 
}

function TeletypeGadget() {

var path = gadget.storage.extract("TeletypeRSS.dll");

PrepareControl(path, "D92EDB2C-3B62-49ED-9568-9706F095C8C0", "TeletypeRSS.TeletypeRSSGadget",
	"TeletypeRSS.dll", "TeletypeRSS", "423FB305-07A6-4068-B657-9E86F540656C");
PrepareControl(path, "4996C509-E292-48A6-BA58-A3D23926020D", "TeletypeRSS.TeletypeRSSPropPage",
	"TeletypeRSS.dll", "TeletypeRSSPropPage", "423FB305-07A6-4068-B657-9E86F540656C");
}

TeletypeGadget.prototype.onOpen = function() {
var ObjXML = "<object classId=\"clsid:D92EDB2C-3B62-49ED-9568-9706F095C8C0\" name=\"RSST\" height=\"100%\" width=\"100%\" cursor=\"hand\" tooltip=\"&GADGET_TIP_TEXT;\"></object>";
view.appendElement(ObjXML);
	try{
		if(RSST.object == null){
			view.alert(COULDNT_LOAD_ACTIVEX);
			return;
		}
		rss = RSST.object;
		rss.LoadSettings();
	}catch(e){
			view.alert(COULDNT_LOAD_ACTIVEX);
			return;
	}
	plugin.onAddCustomMenuItems = TeletypeGadget.addCustomMenuItems;
};

TeletypeGadget.prototype.onClose = function() {
//	delete rss;
rss = null;
};

TeletypeGadget.prototype.onMouseOver = function() {

};

TeletypeGadget.prototype.onClick = function() {
	rss.OpenCurrentLink();
};


TeletypeGadget.addCustomMenuItems = function(menu) {
	menu.AddItem(GADGET_MENU_PAUSE, rss.Paused ? gddMenuItemFlagChecked : 0, TeletypeGadget.pauseGadget);
	menu.AddItem(GADGET_MENU_OPTIONS, 0, TeletypeGadget.showOptions);
if(!rss.Registered)
	menu.AddItem(GADGET_MENU_REGISTER, 0, TeletypeGadget.registerGadget);
};

TeletypeGadget.pauseGadget = function() { 
	rss.Pause();
};

TeletypeGadget.showOptions = function() { 
	rss.ShowSettings();
	rss.SaveSettings();
};

TeletypeGadget.registerGadget = function() { 
	rss.RegisterGadget();
};